unit FmExportU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls,uOOCalc, StdCtrls, ExtCtrls, Buttons,IniFiles;

type
  TFormExport = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    RadioGroup1: TRadioGroup;
    rbExcel: TRadioButton;
    rbCalc: TRadioButton;
    Label1: TLabel;
    pbExport: TProgressBar;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormExport: TFormExport;

implementation
uses
MainF1,Grids,ComObj;
{$R *.dfm}
procedure TFormExport.BitBtn2Click(Sender: TObject);
begin
Close();
end;
//  
 function RefToCell(RowID, ColID: Integer): string;
 var
   ACount, APos: Integer;
 begin
   ACount := ColID div 26;
   APos := ColID mod 26;
   if APos = 0 then
   begin
     ACount := ACount - 1;
     APos := 26;
   end;

   if ACount = 0 then
     Result := Chr(Ord('A') + ColID - 1) + IntToStr(RowID);

   if ACount = 1 then
     Result := 'A' + Chr(Ord('A') + APos - 1) + IntToStr(RowID);

   if ACount > 1 then
     Result := Chr(Ord('A') + ACount - 1) + Chr(Ord('A') + APos - 1) + IntToStr(RowID);
 end;

 // StringGrid Inhalt in Excel exportieren 
// Export StringGrid contents to Excel 
function StringGridToExcelSheet(Grid: TStringGrid; SheetName: string;
   ShowExcel: Boolean): Boolean;
 const
   xlWBATWorksheet = -4167;
 var
   SheetCount, SheetColCount, SheetRowCount, BookCount: Integer;
   XLApp, Sheet, Data: OLEVariant;
   I, J, N, M: Integer;

 begin
   //notwendige Sheetanzahl feststellen 
  SheetCount := (Grid.ColCount div 256) + 1;
   if Grid.ColCount mod 256 = 0 then
     SheetCount := SheetCount - 1;
   //notwendige Bookanzahl feststellen 
  BookCount := (Grid.RowCount div 65536) + 1;
   if Grid.RowCount mod 65536 = 0 then
     BookCount := BookCount - 1;

   //Create Excel-OLE Object 
  Result := False;
   XLApp  := CreateOleObject('Excel.Application');
   try
     //Excelsheet anzeigen 
    if ShowExcel = False then
       XLApp.Visible := False
     else
       XLApp.Visible := True;
     //Workbook hinzufugen 
    for M := 1 to BookCount do
     begin
       XLApp.Workbooks.Add(xlWBATWorksheet);
       //Sheets anlegen 
      for N := 1 to SheetCount - 1 do
       begin
         XLApp.Worksheets.Add;
       end;
     end;
     //Sheet ColAnzahl feststellen 
    if Grid.ColCount <= 256 then
       SheetColCount := Grid.ColCount
     else
       SheetColCount := 256;
     //Sheet RowAnzahl feststellen 
    if Grid.RowCount <= 65536 then
       SheetRowCount := Grid.RowCount
     else
       SheetRowCount := 65536;

     //Sheets befullen 
    for M := 1 to BookCount do
     begin
       for N := 1 to SheetCount do
       begin
         //Daten aus Grid holen 
        Data := VarArrayCreate([1, Grid.RowCount, 1, SheetColCount], varVariant);
         for I := 0 to SheetColCount - 1 do
           for J := 0 to SheetRowCount - 1 do
             if ((I + 256 * (N - 1)) <= Grid.ColCount) and
               ((J + 65536 * (M - 1)) <= Grid.RowCount) then
               Data[J + 1, I + 1] := Grid.Cells[I + 256 * (N - 1), J + 65536 * (M - 1)];
         //------------------------- 
        XLApp.Worksheets[N].Select;
         XLApp.Workbooks[M].Worksheets[N].Name := SheetName + IntToStr(N);
         //Zellen als String Formatieren 
        XLApp.Workbooks[M].Worksheets[N].Range[RefToCell(1, 1),
           RefToCell(SheetRowCount, SheetColCount)].Select;
         XLApp.Selection.NumberFormat := '@';
         XLApp.Workbooks[M].Worksheets[N].Range['A1'].Select;
         //Daten dem Excelsheet ubergeben 
        Sheet := XLApp.Workbooks[M].WorkSheets[N];
         Sheet.Range[RefToCell(1, 1), RefToCell(SheetRowCount, SheetColCount)].Value :=
           Data;
       end;
     end;

       Result := True;

   finally
     //Excel Beenden 
    if (not VarIsEmpty(XLApp)) and (ShowExcel = False) then
     begin
       XLApp.DisplayAlerts := False;
       XLApp.Quit;
       XLAPP := Unassigned;
       Sheet := Unassigned;
     end;
   end;
 end;


procedure TFormExport.BitBtn1Click(Sender: TObject);
label
label1;
var
Calc: TOOCalc;
i,ind,inds:integer;
begin
ind:=Form1.StringGrid1.RowCount;
pbExport.Position:=0;
pbExport.Max:=ind;
if rbCalc.Checked then
begin
//////////
Calc := TOOCalc.Create(ExtractFilePath(ParamStr(0))+'xls\template.xls');
Calc.Visible := False;
i:=0;
inds:=ind-1;
label1:
if i<>inds then
begin
i:=i+1;
pbExport.StepBy(1);
Calc.CellName['A'+IntToStr(i+1)] :=IntToStr(i);
Calc.CellName['B'+IntToStr(i+1)] :=Form1.StringGrid1.Cells[0,i];
Calc.CellName['C'+IntToStr(i+1)] :=Form1.StringGrid1.Cells[1,i];
Calc.CellName['D'+IntToStr(i+1)] :=Form1.StringGrid1.Cells[2,i];
Calc.CellName['E'+IntToStr(i+1)] :=Form1.StringGrid1.Cells[3,i];
Calc.CellName['F'+IntToStr(i+1)] :=Form1.StringGrid1.Cells[4,i];
Calc.CellName['G'+IntToStr(i+1)] :=Form1.StringGrid1.Cells[5,i];
goto label1;
end
else
i:=i+2;
Calc.CellName['F'+IntToStr(i)] :='';
Calc.CellName['G'+IntToStr(i)] :=Form1.Label1.Caption+' ';
Calc.CellName['H1'] :=': '+DateToStr(Date())+'  '+TimeToStr(Time())+' :'+kontragent;
Calc.MarkAsSaved;
Calc.Visible := True;
Calc.Free;
pbExport.Position:=ind;
ShowMessage('  '+DateToStr(Date)+'  '+TimeToStr(Time));

/////////
end
else
begin
if FileExists(AppDir+'ZakazExport1.xls') then DeleteFile(AppDir+'ZakazExport1.xls');
    if StringGridToExcelSheet(Form1.stringGrid1, 'ZAKAZ', True) then
     ShowMessage('  '+DateToStr(Date)+'  '+TimeToStr(Time)) else
     ShowMessage('  !.  !');
     end;
end;

procedure TFormExport.FormShow(Sender: TObject);
begin
pbExport.Position:=0;
IniFile := TIniFile.Create(AppDir+'settings.ini');
if IniFile.ReadString('OptionsWork','ExcelExportOn','0') = '1' then rbExcel.Checked:=True else rbCalc.Checked:=True;

IniFile.Free; {  ,      };
end;

end.
