// Copyright Alexander Ivliutin (mailto:cacxa@yandex.ru), 2007

{
 ,      :

 1)        ,     Microsoft Excel ( .xlt)
      - TOOCalc.Load    -  .xlt,     AsTemplate = True
       ,     .
          ,    AsTemplate  True,
            locked,       

 2)    ( TOOCalc.InsertRow,   )        .
    ,      8- ,    8- .
     TOOCalc.InsertRow(9),      9- ,    " ".

      (..  , ,   ..). !    !

                (. - TOOCalc.LoadMergedCells).
        Range   IsMerged  Boolean.    True,            !
    ..    .

         .       merged1, merged2, ets. ( ,   !)
        TOOCalc.LoadMergedCells,         TOOMergedCells.
         TOOCalc.InsertRow     ,    TOOMergedCells.

      , ,        .   -      -   .   cacxa@yandex.ru
}
unit uOOCalc;

interface

uses ComObj, SysUtils, Variants, dbgrids, Classes;

const
  ooBold: Integer = 150; //  "" 
  ooMerged = 'merged';
  ooTemplateExt = '.xlt';

type
  TOORange = record
    ColFrom: Integer;
    RowFrom: Integer;
    ColCount: Integer;
    RowCount: Integer;
  end;
  POORange = ^TOORange;

  //   
  // .    
  TOOMergedCells = class
    FList: TList;
  private
    function GetItem(AIndex: Integer): TOORange;
    procedure SetItem(AIndex: Integer; const AValue: TOORange);
  public
    constructor Create;
    destructor Destroy; override;

    procedure Add(ARange: TOORange); overload;
    procedure Add(AColFrom, ARowFrom, AColCount, ARowCount: Integer); overload;
    procedure Clear;
    function Count: Integer;
    procedure Delete(AIndex: Integer);

    property Items[Index: Integer]: TOORange read GetItem write SetItem; default;
  end;

  TOOCalc = class
    FObj: Variant; //   
    FDocument: Variant; // 
    FDesktop: Variant; // OpenOffice desktop reference (not used now)
    FActiveSheet: Variant; // Active sheet
    FVisible: Boolean;
    FMergedCells: TOOMergedCells;
  private
    //      file:///c:/temp/test.xls
    function FileName2URL(AFileName: String): String;
    //    [0, 0]   CreateValue    0
    function CreateParam(AName: string; AData: Variant): Variant;
    //   " " - " "
    function CreateValue(AName: string; AData: Variant): Variant;
    // /  Calc
    procedure SetVisible(const Value: Boolean);
    //   Cell
    function GetCell(ARow, ACol: Integer): Variant;
    procedure SetCell(ARow, ACol: Integer; const Value: Variant);
    //   CellName
    function GetCellName(AName: String): Variant;
    procedure SetCellName(AName: String; const Value: Variant);
    //   Bold -     
    function GetBold(ARow, ACol: Integer): Boolean;
    procedure SetBold(ARow, ACol: Integer; const Value: Boolean);
    //     Range
    function ParseRange(ARange: Variant): TOORange; overload;
  public
    //   .  AFileName <> ''   
    constructor Create(AFileName: String);
    destructor Destroy; override;

    //  ,  True  
    function ActivateSheet(AIndex: Integer): Boolean;
    //       .       ,    . . SaveAsExcel97  Excel97
    function GetSupportedFileTypes: String;
    //   
    procedure FreeDocument(ACloseApp: Boolean);
    //  ,     ARow ;   FMergedCells ,    merge
    procedure InsertRow(ARow: Integer; ATryToMerge: Boolean);
    //     AFileName
    procedure Load(AFileName: String);
    //        FMergedCells,    merged1, merged2, ets.
    procedure LoadMergedCells; overload;
    //        FMergedCells,   ...    , .. - getIsMerged  true,          merged 
    procedure LoadMergedCells(AName: String); overload;
    //     ()
    procedure MarkAsSaved;
    //   
    procedure New;
    //  
    procedure OODispatch(ACommand: string; AParams: Variant);
    //     Range
    function ParseRange(AName: String; ALoadMergedCells: Boolean): TOORange; overload;
    //     ARow
    procedure RemoveRow(ARow: Integer);
    //   ,      Load.   New   
    procedure Save;
    //      Excel97. . - GetSupportedFileTypes
    procedure SaveAsExcel97(AFileName: String);
    //   (   )
    procedure SetColumnWidth(ACol: Integer; AValue: Integer);

    //        
    function GetRange(ARow, ACol, AHeight, AWidth: Integer): Variant; overload;
    //         
    function GetRange(AName: String): Variant; overload;
    //       , ARow, ACol -    
    procedure SetRange(ARow, ACol: Integer; const AValue: Variant); overload;
    //        
    procedure SetRange(AName: String; const AValue: Variant); overload;

    //  DBGrid   
    class procedure GridToExcel(AGrid: TDBGrid);

    property Bold[ARow, ACol: Integer]: Boolean read GetBold write SetBold;
    property Cell[ARow, ACol: Integer]: Variant read GetCell write SetCell; default;
    property CellName[AName: String]: Variant read GetCellName write SetCellName;
    property Visible: Boolean read FVisible write SetVisible;
  end;

implementation

{ TOOCalc }

function TOOCalc.ActivateSheet(AIndex: Integer): Boolean;
begin
  Result := False;
  if not VarIsNull(FDocument) then
  begin
    FActiveSheet := FDocument.getSheets.getByIndex(AIndex - 1);
    Result:= True;
    Sleep(50); //Asyncronus, so better give it time to make the change
  end;
end;

constructor TOOCalc.Create(AFileName: String);
begin
  FMergedCells := nil;
  FObj := CreateOleObject('com.sun.star.ServiceManager');
  if VarIsEmpty(FObj) or VarIsNull(FObj) then
    raise Exception.Create('  com- "com.sun.star.ServiceManager"');
  FVisible := False;
  FDocument := Null;
  if AFileName = '' then // new document
    New
  else
    Load(AFileName);
end;

function TOOCalc.CreateParam(AName: string; AData: Variant): Variant;
begin
  Result := VarArrayCreate([0, 0], varVariant);
  Result[0] := CreateValue(AName, AData);
end;

function TOOCalc.CreateValue(AName: string; AData: Variant): Variant;
var
  Reflection: Variant;
begin
  Reflection:= FObj.createInstance('com.sun.star.reflection.CoreReflection');
  Reflection.forName('com.sun.star.beans.PropertyValue').createObject(Result);
  result.Name := AName;
  if not VarIsNull(AData) then
    result.Value:= AData;
end;

destructor TOOCalc.Destroy;
begin
  FMergedCells.Free;
  FreeDocument(False);
  FObj := Null;
  inherited;
end;

procedure TOOCalc.OODispatch(ACommand: string; AParams: Variant);
var
  Dispatcher, Frame: Variant;
begin
  if not VarIsNull(FDocument) then
  begin
    if (VarIsEmpty(AParams) or VarIsNull(AParams)) then
      AParams:= VarArrayCreate([0, -1], varVariant);
    Frame:= FDocument.getCurrentController.getFrame;
    Dispatcher:= FObj.createInstance('com.sun.star.frame.DispatchHelper');
    Dispatcher.executeDispatch(Frame, ACommand, '', 0, AParams);
  end;
end;

function TOOCalc.FileName2URL(AFileName: String): String;
begin
  result:= '';
  if LowerCase(Copy(AFileName, 1, 8)) <> 'file:///' then
    Result := 'file:///';
  Result := Result + StringReplace(AFileName, '\', '/', [rfReplaceAll, rfIgnoreCase]);
end;

procedure TOOCalc.FreeDocument(ACloseApp: Boolean);
begin
  if not VarIsNull(FDocument) then
  begin
    if ACloseApp then
      FDocument.Dispose;
    FActiveSheet := Null;
    FDocument := Null;
  end;
end;

function TOOCalc.GetSupportedFileTypes: String;
var
  FF: Variant;
  FilterNames: Variant;
  i: Integer;
begin
  Result := '';
  try
    FF := FObj.CreateInstance('com.sun.star.document.FilterFactory');
    FilterNames := FF.getElementNames;
    i := 0;
    while True do
      try
        Result := Result + FilterNames[i] + #13#10;
        Inc(i);
      except
        Break;
      end;
  finally
    FF := Unassigned;
  end;
end;

function TOOCalc.GetBold(ARow, ACol: Integer): Boolean;
var
  Cell: Variant;
begin
  Result := False;
  if VarIsNull(FActiveSheet) then
    Exit;
  Cell := FActiveSheet.getCellByPosition(ACol - 1, ARow - 1);
  Result := Cell.getText.createTextCursor.CharWeight = ooBold;
end;

procedure TOOCalc.SetBold(ARow, ACol: Integer; const Value: Boolean);
var
  Cell: Variant;
begin
  if VarIsNull(FActiveSheet) then
    Exit;
  Cell := FActiveSheet.getCellByPosition(ACol - 1, ARow - 1);
  Cell.getText.createTextCursor.CharWeight := ooBold;
end;

function TOOCalc.GetCell(ARow, ACol: Integer): Variant;
begin
  Result := Null;
  if VarIsNull(FActiveSheet) then
    Exit;
  Result := FActiveSheet.getCellByPosition(ACol - 1, ARow - 1).getFormula;
end;

function TOOCalc.GetCellName(AName: String): Variant;
begin
  Result := Null;
  if VarIsNull(FActiveSheet) then
    Exit;
  Result := FActiveSheet.getCellRangeByName(AName).getCellByPosition(0, 0).getFormula;
end;

procedure TOOCalc.InsertRow(ARow: Integer; ATryToMerge: Boolean);
var
  i: Integer;
begin
  if VarIsNull(FDocument) then
    Exit;
  if VarIsNull(FActiveSheet) then
    Exit;
  FActiveSheet.getRows.insertByIndex(ARow - 1, 1);

  if ATryToMerge and Assigned(FMergedCells) then
    for i := 0 to FMergedCells.Count - 1 do
      if (FMergedCells[i].RowFrom = ARow - 1) and (FMergedCells[i].RowCount = 1) then
        FActiveSheet.getCellRangeByPosition(FMergedCells[i].ColFrom - 1, ARow - 1, FMergedCells[i].ColFrom + FMergedCells[i].ColCount - 2, ARow - 1).merge(True);
end;

procedure TOOCalc.Load(AFileName: String);
var
  Param: Variant;
begin
  FreeDocument(True);
  FDesktop := FObj.CreateInstance('com.sun.star.frame.Desktop');

  Param := VarArrayCreate([0, 1], varVariant);
  Param[0] := CreateValue('AsTemplate', AnsiCompareStr(ExtractFileExt(AFileName), ooTemplateExt) = 0);
  Param[1] := CreateValue('Hidden', not Visible);

  FDocument := FDesktop.LoadComponentFromURL(FileName2URL(AFileName), '_blank', 0, Param);
  ActivateSheet(1);
end;

procedure TOOCalc.LoadMergedCells;
var
  i: Integer;
begin
  if VarIsNull(FActiveSheet) then
    Exit;
  if not Assigned(FMergedCells) then
    FMergedCells := TOOMergedCells.Create
  else
    FMergedCells.Clear;

  for i := 1 to MaxInt do
    try
      FMergedCells.Add(ParseRange(ooMerged + IntToStr(i), False));
    except
      Break;
    end;
end;

procedure TOOCalc.LoadMergedCells(AName: String);
var
  RangeRec: TOORange;
  i, i1, j, j1: Integer;
  Merged: Variant;
begin
  if VarIsNull(FActiveSheet) then
    Exit;
  if not Assigned(FMergedCells) then
    FMergedCells := TOOMergedCells.Create
  else
    FMergedCells.Clear;
  RangeRec := ParseRange(AName, False);

  i := RangeRec.RowFrom;
  while i < RangeRec.RowFrom + RangeRec.RowCount do
  begin
    for i1 := i to RangeRec.RowFrom + RangeRec.RowCount - 1 do
    begin
      j := RangeRec.ColFrom;
      while j < RangeRec.ColFrom + RangeRec.ColCount do
      begin
        for j1 := j to RangeRec.ColFrom + RangeRec.ColCount - 1 do
          if (j <> j1) or (i <> i1) then // ..      
          begin
            Merged := FActiveSheet.getCellRangeByPosition(j - 1, i - 1, j1 - 1, i1 - 1).IsMerged;
            if VarIsType(Merged, varBoolean) and Merged then
              FMergedCells.Add(j, i, j1 - j + 1, i1 - i + 1);
          end;
        Inc(j);
      end;
    end;
    Inc(i);
  end;
end;

procedure TOOCalc.MarkAsSaved;
begin
  if VarIsNull(FDocument) then
    Exit;
  if VarIsNull(FActiveSheet) then
    Exit;
  FDocument.setModified(False);
end;

procedure TOOCalc.New;
begin
  FreeDocument(True);
  FDesktop := FObj.CreateInstance('com.sun.star.frame.Desktop');
    //Create the document...
  FDocument:= FDesktop.LoadComponentFromURL('private:factory/scalc', '_blank', 0, CreateParam('Hidden', not Visible));
  ActivateSheet(1);
end;

function TOOCalc.ParseRange(AName: String; ALoadMergedCells: Boolean): TOORange;
var
  Range: Variant;
begin
  FillChar(Result, Sizeof(Result), 0);
  if VarIsNull(FActiveSheet) then
    Exit;
  Range := FActiveSheet.getCellRangeByName(AName);
  Result := ParseRange(Range);
  if ALoadMergedCells then
    LoadMergedCells;
end;

function TOOCalc.ParseRange(ARange: Variant): TOORange;
var
  Address: Variant;
begin
  Address := ARange.getRangeAddress;
  Result.ColFrom := Address.StartColumn + 1;
  Result.RowFrom := Address.StartRow + 1;
  Result.ColCount := Address.EndColumn - Result.ColFrom + 2;
  Result.RowCount := Address.EndRow - Result.RowFrom + 2;
end;

procedure TOOCalc.RemoveRow(ARow: Integer);
begin
  if VarIsNull(FDocument) then
    Exit;
  if VarIsNull(FActiveSheet) then
    Exit;
  FActiveSheet.getRows.removeByIndex(ARow, 1);
end;

procedure TOOCalc.SetCell(ARow, ACol: Integer; const Value: Variant);
begin
  if VarIsNull(FActiveSheet) then
    Exit;
  FActiveSheet.getCellByPosition(ACol - 1, ARow - 1).setString(Value);
end;

procedure TOOCalc.SetCellName(AName: String; const Value: Variant);
begin
  if VarIsNull(FActiveSheet) then
    Exit;
  FActiveSheet.getCellRangeByName(AName).getCellByPosition(0, 0).setString(Value);
end;

procedure TOOCalc.SetVisible(const Value: Boolean);
begin
  if Value = FVisible then
    Exit;
  if VarIsNull(FDocument) then
    Exit;
  FDocument.getCurrentController.getFrame.getContainerWindow.setVisible(Value);
  FVisible := Value;
end;

procedure TOOCalc.Save;
begin
  if VarIsNull(FDocument) then
    Exit;
  if VarIsNull(FActiveSheet) then
    Exit;
  FDocument.store;
end;

procedure TOOCalc.SaveAsExcel97(AFileName: String);
begin
  if VarIsNull(FDocument) then
    Exit;
  if VarIsNull(FActiveSheet) then
    Exit;
  FDocument.storeToURL(FileName2URL(AFileName), CreateParam('FilterName', 'MS Excel 97'));
end;

procedure TOOCalc.SetColumnWidth(ACol: Integer; AValue: Integer);
begin
  if VarIsNull(FActiveSheet) then
    Exit;
  FActiveSheet.getColumns.getByIndex(ACol - 1).setPropertyValue('Width', AValue);
end;

function TOOCalc.GetRange(ARow, ACol, AHeight, AWidth: Integer): Variant;
var
  Range: Variant;
  i, j: Integer;
begin
  Result := Null;
  if VarIsNull(FActiveSheet) then
    Exit;
  Range := FActiveSheet.getCellRangeByPosition(ACol - 1, ARow - 1, ACol + AWidth - 1, ARow + AHeight - 1);
  Result := VarArrayCreate([0, AHeight - 1, 0, AWidth - 1], VarVariant);

  for i := 0 to AHeight - 1 do
    for j := 0 to AWidth - 1 do
      Result[i, j] := Range.getCellByPosition(j, i).getFormula;
end;

function TOOCalc.GetRange(AName: String): Variant;
var
  Range: Variant;
  i, j: Integer;
  Height, Width: Integer;
  RangeRec: TOORange;
begin
  Result := Null;
  if VarIsNull(FActiveSheet) then
    Exit;
  Range := FActiveSheet.getCellRangeByName(AName);
  RangeRec := ParseRange(Range);
  Height := RangeRec.RowCount;
  Width := RangeRec.ColCount;

  Result := VarArrayCreate([0, Height - 1, 0, Width - 1], VarVariant);

  for i := 0 to Height - 1 do
    for j := 0 to Width - 1 do
      Result[i, j] := Range.getCellByPosition(j, i).getFormula;
end;

procedure TOOCalc.SetRange(ARow, ACol: Integer; const AValue: Variant);
var
  i, j: Integer;
  RowFrom, ColFrom, RowTo, ColTo: Integer;
begin
  if VarIsNull(FActiveSheet) then
    Exit;
  if not VarIsArray(AValue) or (VarArrayDimCount(AValue) <> 2) then
    raise Exception.Create('TOOCalc.SetRange:  AValue      2');

  RowFrom := VarArrayLowBound(AValue, 1);
  RowTo := VarArrayHighBound(AValue, 1);
  ColFrom := VarArrayLowBound(AValue, 2);
  ColTo := VarArrayHighBound(AValue, 2);

  for i := RowFrom to RowTo do
    for j := ColFrom to ColTo do
      Cell[ARow + i - RowFrom, ACol + j - ColFrom] := AValue[i, j];
end;

procedure TOOCalc.SetRange(AName: String; const AValue: Variant);
var
  i, j: Integer;
  RowFrom, ColFrom, RowTo, ColTo: Integer;
  Range: Variant;
begin
  if VarIsNull(FActiveSheet) then
    Exit;
  if not VarIsArray(AValue) or (VarArrayDimCount(AValue) <> 2) then
    raise Exception.Create('TOOCalc.SetRange:  AValue      2');

  RowFrom := VarArrayLowBound(AValue, 1);
  RowTo := VarArrayHighBound(AValue, 1);
  ColFrom := VarArrayLowBound(AValue, 2);
  ColTo := VarArrayHighBound(AValue, 2);

  Range := FActiveSheet.getCellRangeByName(AName);

  for i := RowFrom to RowTo do
    for j := ColFrom to ColTo do
      Range.getCellByPosition(j - ColFrom, i - RowFrom).SetString(AValue[i, j])
end;

class procedure TOOCalc.GridToExcel(AGrid: TDBGrid);
var
  I, J, Cnt: Integer;
  Calc: TOOCalc;
  V: Variant;
begin
  Calc := TOOCalc.Create('');
  try
    Cnt := 0;
    //  - 
    for I := 0 to AGrid.Columns.Count - 1 do
      if AGrid.Columns[I].Visible then
        Inc(Cnt);
    if Cnt > 0 then
    begin
      V := VarArrayCreate([0, 0, 0, Cnt - 1], varVariant);
      with AGrid.DataSource.DataSet do
      begin
        DisableControls;
        try
          J := 0;
          for I := 0 to AGrid.Columns.Count - 1 do
            if AGrid.Columns[I].Visible then
            begin
              V[0, J] := AGrid.Columns[I].Title.Caption;
              Inc(J);
              Calc.SetColumnWidth(I + 1, Trunc(AGrid.Columns[I].Width / 3 * 100));
              Calc.Bold[1, I + 1] := True;
            end;
          Calc.SetRange(1, 1, V);
          First;
          while not Eof do
          begin
            J := 0;
            for I := 0 to AGrid.Columns.Count - 1 do
              if AGrid.Columns[I].Visible then
              begin
                V[0, J] := AGrid.Columns[I].Field.AsString;
                Inc(J);
              end;
            Calc.SetRange(RecNo + 1, 1, V);
            Next;
          end;
          First;
        finally
          EnableControls;
        end;
      end;
      Calc.MarkAsSaved;
      Calc.Visible := True;
    end;
  finally
    Calc.Free;
  end;
end;

{ TOOMergedCells }

procedure TOOMergedCells.Add(ARange: TOORange);
var
  Range: POORange;
begin
  Range := AllocMem(Sizeof(TOORange));
  Range^ := ARange;
  FList.Add(Range);
end;

procedure TOOMergedCells.Add(AColFrom, ARowFrom, AColCount, ARowCount: Integer);
var
  Range: TOORange;
begin
  Range.ColFrom := AColFrom;
  Range.RowFrom := ARowFrom;
  Range.ColCount := AColCount;
  Range.RowCount := ARowCount;
  Add(Range);
end;

procedure TOOMergedCells.Clear;
begin
  while Count > 0 do
    Delete(0);
end;

function TOOMergedCells.Count: Integer;
begin
  Result := FList.Count;
end;

constructor TOOMergedCells.Create;
begin
  FList := TList.Create;
end;

procedure TOOMergedCells.Delete(AIndex: Integer);
begin
  FreeMem(FList.Items[AIndex], Sizeof(TOORange));
  FList.Delete(AIndex);
end;

destructor TOOMergedCells.Destroy;
begin
  Clear;
  FList.Free;
  inherited;
end;

function TOOMergedCells.GetItem(AIndex: Integer): TOORange;
begin
  Result := POORange(FList[AIndex])^;
end;

procedure TOOMergedCells.SetItem(AIndex: Integer; const AValue: TOORange);
begin
  POORange(FList[AIndex])^ := AValue;
end;

end.
